## Detector Specific troubleshooting


## AGIPD

### No corrected data even though there are available trains.

It has been reported more than once through the instruments and DOC that there offline correction showed didn't produce any data. And after the DOC checked the reports there is warning for no trains available to correct for all modules, therefore no processed data available.

This can happen in case the offline calibration is configured to correct illuminated data based on the LitFrameFinder device. This device points to the calibration pipeline which frames are illuminated to process. In case the data didn't have any no data correction will take place and no processed files will be produced.

![No LitFrames](../static/troubleshooting/no_litframes.png)

One of the reason for this can be that there were no beam at the time when the data was acquired. This is something the instrument scientists should be aware of and it is usually possible to check the shutter configuration switches for this particular run. As the shutter switches names can be changed. It wont be included here to avoid giving outdated dataset key names.

Below is a reason a table on the shutter switches state for a run acquired with no beam.

![No beam](../static/troubleshooting/shutter_run_state.png)


<!-- ## DSSC

## Epix100 -->

## Gotthard2


### GH2-25um: Correction fails No trains to correct error in PDF report.
![GH2 25um No trains to correct](../static/troubleshooting/gh2_25um_no_trains_to_correct.png)

Check the corresponding sequence file using similar to what is mentioned [in the general troubleshooting section](./troubleshooting.md#processing-failed-and-report-mentions-no-trains-to-process)

For 25um it is expected to find data for two modules (two separate receivers). Below is an example
when a run had missing trains for one of the two modules. This is the out of `h5glance`

```bash
module load exfel exfel-python
h5glance /gpfs/exfel/exp/SPB/202401/p005476/raw/r0020/RAW-R0020-GH200-S00000.h5 INSTRUMENT/SA1_XTD9_HIREX/DET
```

```bash
/gpfs/exfel/exp/SPB/202401/p005476/raw/r0020/RAW-R0020-GH200-S00000.h5/INSTRUMENT/SA1_XTD9_HIREX/DET
├GOTTHARD2_MASTER:daqOutput
│ └data (3 attributes)
│   ├adc	[uint16: 100 × 2720 × 1280] (4 attributes)
│   ├bunchId	[uint64: 100 × 2720] (17 attributes)
│   ├frameNumber	[uint64: 100 × 2720] (17 attributes)
│   ├gain	[uint8: 100 × 2720 × 1280] (4 attributes)
│   ├memoryCell	[uint8: 100 × 2720] (17 attributes)
│   ├timestamp	[float64: 100 × 2720] (17 attributes)
│   └trainId	[uint64: 100] (1 attributes)
└GOTTHARD2_SLAVE:daqOutput
  └data (3 attributes)
    ├adc	[uint16: 0 × 2720 × 1280] (4 attributes)
    ├bunchId	[uint64: 0 × 2720] (17 attributes)
    ├frameNumber	[uint64: 0 × 2720] (17 attributes)
    ├gain	[uint8: 0 × 2720 × 1280] (4 attributes)
    ├memoryCell	[uint8: 0 × 2720] (17 attributes)
    ├timestamp	[float64: 0 × 2720] (17 attributes)
    └trainId	[uint64: 0] (1 attributes)
```

## Jungfrau

### No constants retrieved for burst mode data

To streamline the operation in burst mode, we have decided to exclusively inject fixed gain constants into the database, regardless of the operational mode. Burst mode operates solely at high gain, and the high gain constant remains consistent between fixed and adaptive gain settings. Consequently, we have opted to only incorporate fixed gain constants. The middlelayer responsible for executing dark runs has been adjusted to accommodate this change.

There have been instances where instruments acquired dark runs manually, posing a risk of mistakenly acquiring these runs in adaptive gain mode. Although not anticipated from an offline calibration perspective, such occurrences will be managed by issuing a warning and employing the adaptive gain constant. If dark runs were not performed, an error will be reported due to either the absence of dark runs or the retrieval of burst mode adaptive dark runs that are more than 3 days old.

<!-- ## LPD

## PnCCD -->
